﻿@using Microsoft.Extensions.Localization
@using System.IO
@using System.Text
@using ElectronNET.API
@using Newtonsoft.Json
@using OTaskForce.Singletons
@using Overtest.SharedLibraries.ProgrammingTasksShared

@inject IStringLocalizer<ProjectPropertiesEditor> _localizer
@inject ProjectsOperator _projectsOperator

<section class="position-absolute p-3" style="top: 0; bottom: 0; left: 0; right: 0; overflow-y: auto;">
    @if (_model == null)
    {
        <div class="alert alert-dark">@_localizer["Зачекайте, дані завантажуються..."]</div>
    }
    else
    {
        <EditForm Model="_model" OnValidSubmit="async () => await OnValidSubmitAsync()" OnInvalidSubmit="async () => await OnInvalidSubmitAsync()">
            <DataAnnotationsValidator/>
            
            <div class="mt-0 mb-3">
                <label>@_localizer["Ідентифікатор завдання (Guid)"]</label>
                <div class="input-group">
                    <InputText @bind-Value="@_model.ProgrammingTaskId" class="form-control"/>
                    <button type="button" @onclick="() => _model.ProgrammingTaskId = Guid.NewGuid().ToString()" class="btn btn-outline-secondary" title="@_localizer["Згенерувати новий ідентифікатор"]">
                        <i class="fas fa-sync-alt"></i>
                    </button>
                </div>
                <div class="form-text">
                    @_localizer["Ідентифікатор завдання є унікальним кодом типу Guid, який визначає завдання у системі."]
                    @_localizer["Якщо ви хочете створити нове завдання на основі вже існуючого, згенеруйте новий Guid."]
                    @_localizer["Якщо ж ви хочете відредагувати існуюче завдання, збережіть його ідентифікатор - cтара версія завдання буде автоматично перезаписана новою, створеною вами зараз."]
                </div>
                <span class="text-danger"><ValidationMessage For="() => _model.ProgrammingTaskId" /></span>
            </div>
            
            <div class="form-floating mt-0 mb-3">
                <InputText @bind-Value="@_model.ProgrammingTaskTitle" class="form-control"/>
                <label>@_localizer["Назва завдання"]</label>
                <div class="form-text">@_localizer["Публічна назва завдання, за якою його можна буде найти у системі. Використовуйте виключно унікальні назви."]</div>
                <span class="text-danger"><ValidationMessage For="() => _model.ProgrammingTaskTitle" /></span>
            </div>
            
            <div class="form-floating mt-0 mb-3">
                <InputText @bind-Value="@_model.ProgrammingTaskCategory" class="form-control"/>
                <label>@_localizer["Назва категорії завдання"]</label>
                <div class="form-text">@_localizer["Вкажіть назву категорії завдань, до якої буде додано це завдання."]</div>
                <span class="text-danger"><ValidationMessage For="() => _model.ProgrammingTaskCategory" /></span>
            </div>
            
            <div class="form-floating mt-0 mb-3">
                <InputNumber @bind-Value="@_model.ProgrammingTaskDifficulty" class="form-control"/>
                <label>@_localizer["Складність завдання"]</label>
                <div class="form-text">@_localizer["Вкажіть рейтинг від 1 до 100, який додається користувачу за повне розв'язання цього завдання."]</div>
                <span class="text-danger"><ValidationMessage For="() => _model.ProgrammingTaskDifficulty" /></span>
            </div>
            
            <button type="submit" class="btn btn-lg btn-primary rounded-circle position-fixed shadow-lg" style="bottom: 20px; right: 20px; width: 50px; height: 50px; z-index: 1000;">
                <i class="fas fa-save"></i>
            </button>
        </EditForm>
    }
</section>

@code
{
    private TaskForceProjectPropertiesStore _model = null;
    
    protected override async Task OnInitializedAsync()
    {
        _model = new TaskForceProjectPropertiesStore();
        
        try
        {
            var projectPropertiesJson = await File.ReadAllTextAsync(_projectsOperator.CurrentProjectControl.ProjectFileFullPath, Encoding.UTF8);
            _model = JsonConvert.DeserializeObject<TaskForceProjectPropertiesStore>(projectPropertiesJson);
        }
        catch (Exception ex)
        {
            throw new FileLoadException(null, _projectsOperator.CurrentProjectControl.ProjectFileFullPath, ex);
        }
    }

    private async Task OnValidSubmitAsync()
    {
        try
        {
            _ = new Guid(_model.ProgrammingTaskId);
        }
        catch (Exception)
        {
            await OnInvalidSubmitAsync();
            return;
        }

        await File.WriteAllTextAsync(_projectsOperator.CurrentProjectControl.ProjectFileFullPath,
            JsonConvert.SerializeObject(_model, Formatting.Indented), Encoding.UTF8);
    }

    private async Task OnInvalidSubmitAsync()
    {
        Electron.Dialog.ShowErrorBox(_localizer["Помилка збереження"], _localizer["Зміни не збережено через помилку у вказаних вами даних. Перевірте правильність заповнення форми ще раз, і повторіть спробу."]);
    }
}